using Exferia_Aplicacion.General;
using Exferia_Aplicacion.Modelos_Informes;
using Exferia_Aplicacion.Visualizacion;
using Exferia_Controles;
using Exferia_EntityFramework;
using Exferia_Formularios;
using Exferia_General;
using Exferia_HotelPuntoVenta._0_Modelos;
using Exferia_HotelPuntoVenta._3_Vistas;
using Exferia_HotelPuntoVenta._3_Vistas.Controladoras;
using Exferia_HotelPuntoVenta.General;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Globalization;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using static Exferia_Aplicacion.General.Enumerados;

namespace Exferia_HotelPuntoVenta._3_Vistas
{
    public partial class P_AgrupacionTerminal : Exferia_Formularios.P_Base_Mantenimientos
    {
        #region Variables Generales
        private P_AgrupacionTerminal_Controladora g_obj_Controladora;

        private bool g_bol_ConstructorPantalla_Terminado_Correctamente = true;
        public PRV_OpcionesDetalle g_mdl_PRV_OpcionesDetalle = null;

        public bool g_bol_Modificando_Terminales = false;
        private bool g_bol_BloquearPorCargaInicial_Terminales_RegistrosSeleccionados = false;

        internal List<INTERNO_Permisos_Modelo> g_lst_INTERNO_Permisos_Modelo = null;

        //Terminales Registros Seleccionados
        private INTERNO_ConfiguracionPantalla_Modelo g_mdl_INTERNO_ConfiguracionPantalla_Modelo_TERMINALES_REGISTROSSELECCIONADOS = null;
        private System.Windows.Forms.Timer g_timer_Terminales_RegistrosSeleccionados_Filtrar = new System.Windows.Forms.Timer();

        //Variables paginador......................................................................................
        public Funciones_Paginador g_obj_Funciones_Paginador;
        private System.Windows.Forms.Timer g_timer_Paginar = new System.Windows.Forms.Timer();
        #endregion

        #region Objetos en pantalla
        //Exferia_BarraProgreso
        internal Exferia_BarraProgreso Exferia_BarraProgreso_Terminales_RegistrosSeleccionados_BarraProgreso { get { return ex_pgb_P_AgrupacionTerminal_Terminales_RegistrosSeleccionados_BarraProgreso; } }


        //Exferia_Button
        internal Exferia_Button Exferia_Button_Borrar { get { return ex_btn_P_AgrupacionTerminal_Borrar; } }
        internal Exferia_Button Exferia_Button_Terminales_RegistrosSeleccionados_OrdenListado { get { return ex_btn_P_AgrupacionTerminal_Terminales_RegistrosSeleccionados_OrdenListado; } }


        //Exferia_CheckBox
        internal Exferia_CheckBox Exferia_CheckBox_Terminales_RegistrosSeleccionados_PalabraCompleta { get { return ex_chk_P_AgrupacionTerminal_Terminales_RegistrosSeleccionados_PalabraCompleta; } }
        internal Exferia_CheckBox Exferia_CheckBox_Terminales_RegistrosSeleccionados_MayusculasMinusculas { get { return ex_chk_P_AgrupacionTerminal_Terminales_RegistrosSeleccionados_MayusculasMinusculas; } }

        //Exferia_ComboBox
        internal Exferia_ComboBox Exferia_ComboBox_Terminales_RegistrosSeleccionados_Filtros { get { return ex_cbo_P_AgrupacionTerminal_Terminales_RegistrosSeleccionados_Filtros; } }
        internal Exferia_ComboBox Exferia_ComboBox_Terminales_RegistrosSeleccionados_OrdenListado { get { return ex_cbo_P_AgrupacionTerminal_Terminales_RegistrosSeleccionados_OrdenListado; } }

        //Exferia_DataGridView
        internal Exferia_DataGridView Exferia_DataGridView_Terminales_RegistrosSeleccionados_Listado { get { return ex_dgv_P_AgrupacionTerminal_Terminales_RegistrosSeleccionados_Listado; } }

        //Exferia Label
        internal Exferia_Label Exferia_Label_Codigo { get { return ex_lbl_P_AgrupacionTerminal_Codigo; } }
        internal Exferia_Label Exferia_Label_Descripcion { get { return ex_lbl_P_AgrupacionTerminal_Descripcion; } }

        //Exferia_TextBox
        internal Exferia_TextBox Exferia_TextBox_Codigo { get { return ex_txt_P_AgrupacionTerminal_Codigo; } }
        internal Exferia_TextBox Exferia_TextBox_Descripcion { get { return ex_txt_P_AgrupacionTerminal_Descripcion; } }
        internal Exferia_TextBox Exferia_TextBox_Terminales_RegistrosSeleccionados_Busqueda { get { return ex_txt_P_AgrupacionTerminal_Terminales_RegistrosSeleccionados_Busqueda; } }

        //Exferia_Paginador
        internal Exferia_Paginador Exferia_Paginador_AgrupacionTerminal { get { return ex_Paginador_AgrupacionTerminal; } }
        #endregion

        #region Constructor
        public P_AgrupacionTerminal(INTERNO_ValoresGenerales_Modelo _mdl_INTERNO_ValoresGenerales_Modelo, DateTime _dtt_FechaTrabajo, PRV_OpcionesDetalle _mdl_PRV_OpcionesDetalle)
        {
            InitializeComponent();

            try
            {
                Repintar.Empezar(this);

                g_bol_BloquearPorCargaInicial_Terminales_RegistrosSeleccionados = true;

                CheckForIllegalCrossThreadCalls = false;

                //Empresa seleccionada y fecha de trabajo ....................................................
                P_Base_ValoresGenerales = _mdl_INTERNO_ValoresGenerales_Modelo;
                P_Base_FechaTrabajo = _dtt_FechaTrabajo;

                //Instancias Controladora
                g_obj_Controladora = new P_AgrupacionTerminal_Controladora(this);

                //Datos de Opciones detalle
                g_mdl_PRV_OpcionesDetalle = _mdl_PRV_OpcionesDetalle;

                //Buscar los permisos
                g_lst_INTERNO_Permisos_Modelo = Datos_Generales.Permisos_Buscar(g_mdl_PRV_OpcionesDetalle.opcion);

                //Poner los Botones que no se Spueden poner bloqueados o de solo lectura
                ex_btn_P_AgrupacionTerminal_Borrar.Exferia_Button_Bloqueable = false;
                ex_btn_P_AgrupacionTerminal_Grabar.Exferia_Button_Bloqueable = false;

                //Mirar si hay que bloquear los controles, si solo puede ver los datos
                if ((P_Base_TipoAperturaPantalla != 0 && Datos_Generales.Permisos_Comprobar(g_mdl_PRV_OpcionesDetalle.opcion, g_lst_INTERNO_Permisos_Modelo, (int)G_ENUM_PERMISOS.Modificar, false)) == false)
                {
                    //Bloqueo los Controles
                    SoloLectura.Empezar(this, true);
                }

                //Titulo de la Pantalla .............................................................................
                P_Base_TituloPantalla = _mdl_PRV_OpcionesDetalle.descripcion_TituloMantenimiento;

                if (Variables.G_DCT_CONFIGURACIONPANTALLA != null && Variables.G_DCT_CONFIGURACIONPANTALLA.Count > 0)
                {
                     //Terminales Registros Seleccionados
                    if (Variables.G_DCT_CONFIGURACIONPANTALLA.ContainsKey(g_obj_Controladora.g_obj_ABS_Listado_HPV_Terminales_P_AgrupacionTerminal.NOMBRELISTADO_ALMACENARCONFIGURACION()))
                    {
                        g_mdl_INTERNO_ConfiguracionPantalla_Modelo_TERMINALES_REGISTROSSELECCIONADOS = Variables.G_DCT_CONFIGURACIONPANTALLA[g_obj_Controladora.g_obj_ABS_Listado_HPV_Terminales_P_AgrupacionTerminal.NOMBRELISTADO_ALMACENARCONFIGURACION()];
                    }
                }

                //Tipo de campo Codigo, poner como numérico o texto ...............................
                if (Variables.G_LST_GEN_CONFIGURACION_CAMPOCODIGO != null)
                {
                    //Si no existe es Text
                    if (Variables.G_LST_GEN_CONFIGURACION_CAMPOCODIGO.Where(m => m.nombreCampoCodigo.Equals(nameof(HPV_AgrupacionesTerminales.codigo)) && m.opcion.Equals(g_mdl_PRV_OpcionesDetalle.opcion)).FirstOrDefault() != null)
                    {
                        ex_txt_P_AgrupacionTerminal_Codigo.Exferia_TextBox_Tipos = G_ENUM_TEXTBOX_TIPODATO.Digitos;
                        ex_txt_P_AgrupacionTerminal_Codigo.Exferia_TextBox_Tipo_Decimal_Enteros = ex_txt_P_AgrupacionTerminal_Codigo.Exferia_TextBox_MaxLength;

                        g_obj_Controladora.g_bol_CampoCodigo_Numerico = true;
                    }
                }
                //................................................................................

                // Label con Empresa Seleccionada 
                if (P_Base_ValoresGenerales != null)
                {
                    try
                    {
                        P_Base_Mantenimientos_InformacionEmpresaSeleccionada = P_Base_ValoresGenerales.str_Empresa_Descripcion + " - " +
                                                                "(" + P_Base_FechaTrabajo.ToString("dd/MM/yyyy") + ")";
                    }
                    catch (Exception ex)
                    {
                        //No se muestra mensaje pero se guarda en el log
                        Control_Errores.Errores_Log(ex.Message, ex, nameof(P_AgrupacionTerminal) + "/" + nameof(P_AgrupacionTerminal));
                    }
                }
                //....................................................................................................

                //Bloquear pantalla hasta que termine la carga por defecto .....
                Enabled = false;
                //.............................................................

                g_obj_Funciones_Paginador = new Funciones_Paginador();

            }
            catch (Control_Errores)
            {
                g_bol_ConstructorPantalla_Terminado_Correctamente = false;
            }
            catch (Exception ex)
            {
                g_bol_ConstructorPantalla_Terminado_Correctamente = false;

                //No se muestra mensaje pero se guarda en el log
                Control_Errores.Errores_Log(ex.Message, ex, nameof(P_AgrupacionTerminal) + "/" + nameof(P_AgrupacionTerminal));
            }
            finally
            {
                //Bloquear pantalla hasta que termine la carga por defecto .....
                Enabled = true;
                //.............................................................
            }

        }

        #endregion

        #region Inicio de pantalla
        private void P_AgrupacionTerminal_Load(object sender, EventArgs e)
        {
            try
            {
                #region TIMER PAGINACION
                //Configurar el Timer para Paginacion ###############################################################
                g_timer_Paginar.Interval = 1000;
                g_timer_Paginar.Tick += delegate (object s, EventArgs ee)
                {
                    g_timer_Paginar.Stop();
                    try
                    {
                        g_obj_Controladora.RecargarDatos();
                    }
                    catch (Control_Errores)
                    {
                        Mensajes.MostrarMensaje(Mensajes.G_STR_MENSAJES_GENERAL_ERROR_CARGARDATOSPANTALLA());
                        Salir_P_Base();
                    }

                };
                #endregion

                #region TERMINALES REGISTROS SELECCIONADOS
                //Crear_Columnas
                CrearColumnas_Terminales_RegistrosSeleccionados();

                //Cargar Datos del Como
                Cargar_Filtros_Textos_Terminales_RegistrosSeleccionados();

                //Cargar combo de orden
                Cargar_Combo_Orden_Terminales_RegistrosSeleccionados();

                //Seleccionar Filtro por Defecto en Combo ###############################################################
                ex_cbo_P_AgrupacionTerminal_Terminales_RegistrosSeleccionados_Filtros.SelectedIndex = 0;

                //Poner el tipo de orden si lo hubiera por defecto ######################################
                if (g_mdl_INTERNO_ConfiguracionPantalla_Modelo_TERMINALES_REGISTROSSELECCIONADOS != null &&
                    g_mdl_INTERNO_ConfiguracionPantalla_Modelo_TERMINALES_REGISTROSSELECCIONADOS.LISTADO_ORDEN_DIRECCION_PORDEFECTO != null &&
                    g_mdl_INTERNO_ConfiguracionPantalla_Modelo_TERMINALES_REGISTROSSELECCIONADOS.LISTADO_ORDEN_DIRECCION_PORDEFECTO.Trim().Length > 0)
                {
                    //Descendente
                    if (g_mdl_INTERNO_ConfiguracionPantalla_Modelo_TERMINALES_REGISTROSSELECCIONADOS.LISTADO_ORDEN_DIRECCION_PORDEFECTO.Equals("1"))
                    {
                        Funciones.Cambiar_Imagen_Boton_Orden(0, ex_btn_P_AgrupacionTerminal_Terminales_RegistrosSeleccionados_OrdenListado);
                        ex_btn_P_AgrupacionTerminal_Terminales_RegistrosSeleccionados_OrdenListado.Tag = "1";

                    }
                    //Ascendente
                    else
                    {
                        Funciones.Cambiar_Imagen_Boton_Orden(1, ex_btn_P_AgrupacionTerminal_Terminales_RegistrosSeleccionados_OrdenListado);
                        ex_btn_P_AgrupacionTerminal_Terminales_RegistrosSeleccionados_OrdenListado.Tag = "0";
                    }
                }
                else
                {
                    if (g_obj_Controladora.g_obj_ABS_Listado_HPV_Terminales_P_AgrupacionTerminal.ORDENACION_TIPO_PORDEFECTO().Trim().Length > 0)
                    {
                        //Descendente
                        if (g_obj_Controladora.g_obj_ABS_Listado_HPV_Terminales_P_AgrupacionTerminal.ORDENACION_TIPO_PORDEFECTO().Equals("1"))
                        {
                            Funciones.Cambiar_Imagen_Boton_Orden(0, ex_btn_P_AgrupacionTerminal_Terminales_RegistrosSeleccionados_OrdenListado);
                            ex_btn_P_AgrupacionTerminal_Terminales_RegistrosSeleccionados_OrdenListado.Tag = "1";
                        }
                        //Ascendente
                        else
                        {
                            Funciones.Cambiar_Imagen_Boton_Orden(1, ex_btn_P_AgrupacionTerminal_Terminales_RegistrosSeleccionados_OrdenListado);
                            ex_btn_P_AgrupacionTerminal_Terminales_RegistrosSeleccionados_OrdenListado.Tag = "0";

                        }
                    }
                }

                //Seleccionar Orden por Defecto en Combo #################################################
                if (g_mdl_INTERNO_ConfiguracionPantalla_Modelo_TERMINALES_REGISTROSSELECCIONADOS != null &&
                    g_mdl_INTERNO_ConfiguracionPantalla_Modelo_TERMINALES_REGISTROSSELECCIONADOS.LISTADO_ORDEN_COLUMNA_PORDEFECTO != null &&
                    g_mdl_INTERNO_ConfiguracionPantalla_Modelo_TERMINALES_REGISTROSSELECCIONADOS.LISTADO_ORDEN_COLUMNA_PORDEFECTO.Trim().Length > 0)
                {
                    ex_cbo_P_AgrupacionTerminal_Terminales_RegistrosSeleccionados_OrdenListado.SelectedItem = ex_cbo_P_AgrupacionTerminal_Terminales_RegistrosSeleccionados_OrdenListado.Items.Cast<INTERNO_ComboBox_Modelo>().Where(m => m.Descripcion.Equals(g_mdl_INTERNO_ConfiguracionPantalla_Modelo_TERMINALES_REGISTROSSELECCIONADOS.LISTADO_ORDEN_COLUMNA_PORDEFECTO)).FirstOrDefault();
                }
                else
                {
                    if (g_obj_Controladora.g_obj_ABS_Listado_HPV_Terminales_P_AgrupacionTerminal.ORDENACION_NOMBRECOLUMNA_PORDEFECTO().Trim().Length > 0)
                    {
                        ex_cbo_P_AgrupacionTerminal_Terminales_RegistrosSeleccionados_OrdenListado.SelectedItem = ex_cbo_P_AgrupacionTerminal_Terminales_RegistrosSeleccionados_OrdenListado.Items.Cast<INTERNO_ComboBox_Modelo>().Where(m => m.Identificador.Equals(g_obj_Controladora.g_obj_ABS_Listado_HPV_Terminales_P_AgrupacionTerminal.ORDENACION_NOMBRECOLUMNA_PORDEFECTO())).FirstOrDefault();
                    }
                    else
                    {
                        ex_cbo_P_AgrupacionTerminal_Terminales_RegistrosSeleccionados_OrdenListado.SelectedItem = ex_cbo_P_AgrupacionTerminal_Terminales_RegistrosSeleccionados_OrdenListado.Items.Cast<INTERNO_ComboBox_Modelo>().FirstOrDefault();
                    }
                }

                //Configurar el Timer para Busqueda en el Listado #####################################################
                g_timer_Terminales_RegistrosSeleccionados_Filtrar.Interval = 1000;
                g_timer_Terminales_RegistrosSeleccionados_Filtrar.Tick += delegate (object s, EventArgs ee)
                {
                    g_timer_Terminales_RegistrosSeleccionados_Filtrar.Stop();
                    g_obj_Controladora.Rellenar_DataGridView_Terminales_RegistrosSeleccionados(ex_txt_P_AgrupacionTerminal_Terminales_RegistrosSeleccionados_Busqueda.Text);
                };

                g_bol_BloquearPorCargaInicial_Terminales_RegistrosSeleccionados = false;
                #endregion

            }
            catch (Exception ex)
            {
                //No se muestra mensaje pero se guarda en el log
                Control_Errores.Errores_Log(ex.Message, ex, nameof(P_AgrupacionTerminal) + "/" + nameof(P_AgrupacionTerminal_Load));

                g_bol_ConstructorPantalla_Terminado_Correctamente = false;
            }
        }
        private void P_AgrupacionTerminal_Shown(object sender, EventArgs e)
        {
            try
            {
                if (g_bol_ConstructorPantalla_Terminado_Correctamente)
                {
                    //Obtener los datos del listado de base de datos .............................................
                    g_obj_Controladora.Obtener_Listados_Completo_BaseDatos();

                    //Se queda Esperando a que termine la obtencio de datos de la base de datos para el listado
                    while (g_obj_Controladora.g_bol_Obtencion_Listados_Completo_BaseDatos_Termino == false)
                        Application.DoEvents();
                    //............................................................................................


                    // Si el Tipo de Apertura de Pantalla es Añadir(g_int_tipoAperturaPantalla = 0), se desactivan los botones correspondientes
                    // Añadir
                    if (P_Base_TipoAperturaPantalla == 0)
                    {
                        P_Base_TituloPantalla = P_Base_TituloPantalla + " - Añadir";

                        ActivarBotones(false);

                        //Se cambia el valor de la variable para no salte el evento de se modifico algo
                        g_obj_Controladora.g_bol_Termino_CargaDatos_Inicial = false;

                        //Poner Texto predeterminado y foco
                        if ((P_Base_Campo_1 != null && P_Base_Campo_1.Trim().Length > 0) ||
                            (P_Base_Campo_2 != null && P_Base_Campo_2.Trim().Length > 0))
                        {
                            if (P_Base_Campo_1 != null && P_Base_Campo_1.Trim().Length > 0)
                            {
                                Exferia_TextBox_Codigo.Text = P_Base_Campo_1;
                                Exferia_TextBox_Descripcion.Exferia_TextBox_Foco();
                            }
                            if (P_Base_Campo_2 != null && P_Base_Campo_2.Trim().Length > 0)
                            {
                                Exferia_TextBox_Descripcion.Text = P_Base_Campo_2;
                                Exferia_TextBox_Codigo.Exferia_TextBox_Foco();
                            }
                        }
                        else
                        {
                            Exferia_TextBox_Codigo.Exferia_TextBox_Foco();
                        }
                        
                        g_obj_Controladora.g_bol_Termino_CargaDatos_Inicial = true;
                    }
                    //Modificar
                    else
                    {
                        ActivarBotones(true);

                        //Paginacion
                        if (P_Base_PantallaOrigen != null &&
                           P_Base_PantallaOrigen.P_Base_Objetos_Filtrados != null &&
                           P_Base_PantallaOrigen.P_Base_Objetos_Filtrados.Count > 0)
                        {
                            g_obj_Funciones_Paginador.Listado_ARecorrer(P_Base_PantallaOrigen.P_Base_Objetos_Filtrados.ToList(), 1);

                            // Asignando las paginas totales
                            Exferia_Paginador_AgrupacionTerminal.PaginasTotales = g_obj_Funciones_Paginador.Numero_Paginas_Totales;
                        }
                        else
                        {
                            Exferia_Paginador_AgrupacionTerminal.Visible = false;
                        }

                        g_obj_Controladora.RecargarDatos();
                    }
                }
                else
                {
                    Mensajes.MostrarMensaje(Mensajes.G_STR_MENSAJES_GENERAL_ERROR_CARGARDATOSPANTALLA());
                    Salir_P_Base();
                }
            }
            catch (Control_Errores)
            {
                Mensajes.MostrarMensaje(Mensajes.G_STR_MENSAJES_GENERAL_ERROR_CARGARDATOSPANTALLA());
                Salir_P_Base();
            }
            catch (Exception ex)
            {
                //No se muestra mensaje pero se guarda en el log
                Control_Errores.Errores_Log(ex.Message, ex, nameof(P_AgrupacionTerminal) + "/" + nameof(P_AgrupacionTerminal_Shown));

                Mensajes.MostrarMensaje(Mensajes.G_STR_MENSAJES_GENERAL_ERROR_CARGARDATOSPANTALLA());
                Salir_P_Base();
            }
        }
        public void ActivarBotones(bool _bol_Activar)
        {
            if (Exferia_Paginador_AgrupacionTerminal.Visible)
            {
                Exferia_Paginador_AgrupacionTerminal.Visible = _bol_Activar;
            }

            if (ex_btn_P_AgrupacionTerminal_Borrar.Enabled)
            {
                ex_btn_P_AgrupacionTerminal_Borrar.Enabled = _bol_Activar;
            }
        }
        #endregion


        #region Botones Grabar, Borrar, BuscarCodigo_Siguiente
        private void ex_btn_P_AgrupacionTerminal_Grabar_Click(object sender, EventArgs e)
        {
            Grabar();
        }
        private void Grabar()
        {
            if (//Añadir
                 (P_Base_TipoAperturaPantalla == 0 && Datos_Generales.Permisos_Comprobar(g_mdl_PRV_OpcionesDetalle.opcion, g_lst_INTERNO_Permisos_Modelo, (int)G_ENUM_PERMISOS.Anadir, true)) ||
                 //Modificar
                 (P_Base_TipoAperturaPantalla != 0 && Datos_Generales.Permisos_Comprobar(g_mdl_PRV_OpcionesDetalle.opcion, g_lst_INTERNO_Permisos_Modelo, (int)G_ENUM_PERMISOS.Modificar, true)))
            {
                g_obj_Controladora.GrabarDatos(false);
            }
        }

        private void ex_btn_P_AgrupacionTerminal_Borrar_Click(object sender, EventArgs e)
        {
            Borrar();
        }
        private void Borrar()
        {
            if (Datos_Generales.Permisos_Comprobar(g_mdl_PRV_OpcionesDetalle.opcion, g_lst_INTERNO_Permisos_Modelo, (int)G_ENUM_PERMISOS.Borrar, true))
            {
                g_obj_Controladora.BorrarDatos();
            }
        }

        private void ex_btn_P_AgrupacionTerminal_BuscarCodigoSiguiete_Click(object sender, EventArgs e)
        {
            BuscarCodigoSiguiente();
        }
        private void BuscarCodigoSiguiente()
        {
            INTERNO_ValorDevuelto_Modelo mdl_INTERNO_ValorDevuelto_Modelo = g_obj_Controladora.Buscar_CodigoSiguiente();
            if (mdl_INTERNO_ValorDevuelto_Modelo.TodoCorrecto == false && mdl_INTERNO_ValorDevuelto_Modelo.Mensaje.Trim().Length > 0)
            {
                Mensajes.MostrarMensaje(mdl_INTERNO_ValorDevuelto_Modelo.Mensaje);
            }
            else
            {
                P_Base_SeModificoDatosPantalla = true;
            }
        }
        #endregion

        #region Terminales
        #region Terminales Registros Seleccionados
        private void Cargar_Filtros_Textos_Terminales_RegistrosSeleccionados()
        {
            ex_cbo_P_AgrupacionTerminal_Terminales_RegistrosSeleccionados_Filtros.Items.Clear();
            g_obj_Controladora.g_lst_INTERNO_ComboBox_Modelo_Filtros_Terminales_RegistrosSeleccionados.Clear();

            //Todos
            ex_cbo_P_AgrupacionTerminal_Terminales_RegistrosSeleccionados_Filtros.Items.Add(new INTERNO_ComboBox_Modelo("-1", "Todos", null));

            foreach (INTERNO_ABS_Listado_ColumnasDatos_Modelo mdl_INTERNO_ABS_Listado_ColumnasDatos_Modelo in g_obj_Controladora.g_obj_ABS_Listado_HPV_Terminales_P_AgrupacionTerminal.LISTADO_COLUMNAS().Values.Where(m => (!m.TipoDato.Equals(G_ENUM_TIPOSDATOS.SELECCIONAR)) && g_obj_Controladora.g_lst_ColumnasAMostrar_Terminales_RegistrosSeleccionados.Contains(m.Descripcion_Interna)).ToList())
            {
                INTERNO_ComboBox_Modelo mdl_INTERNO_ComboBox_Modelo = new INTERNO_ComboBox_Modelo(mdl_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Descripcion_Interna, mdl_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Descripcion_AMostrar, null);
                g_obj_Controladora.g_lst_INTERNO_ComboBox_Modelo_Filtros_Terminales_RegistrosSeleccionados.Add(mdl_INTERNO_ComboBox_Modelo);
                ex_cbo_P_AgrupacionTerminal_Terminales_RegistrosSeleccionados_Filtros.Items.Add(mdl_INTERNO_ComboBox_Modelo);
            }
        }

        private void Cargar_Combo_Orden_Terminales_RegistrosSeleccionados()
        {
            ex_cbo_P_AgrupacionTerminal_Terminales_RegistrosSeleccionados_OrdenListado.Items.Clear();

            //Todos
            foreach (INTERNO_ABS_Listado_ColumnasDatos_Modelo mdl_INTERNO_ABS_Listado_ColumnasDatos_Modelo in g_obj_Controladora.g_obj_ABS_Listado_HPV_Terminales_P_AgrupacionTerminal.LISTADO_COLUMNAS().Values.Where(m => (!m.TipoDato.Equals(G_ENUM_TIPOSDATOS.SELECCIONAR)) && g_obj_Controladora.g_lst_ColumnasAMostrar_Terminales_RegistrosSeleccionados.Contains(m.Descripcion_Interna)).ToList())
            {
                INTERNO_ComboBox_Modelo mdl_INTERNO_ComboBox_Modelo = new INTERNO_ComboBox_Modelo(mdl_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Descripcion_Interna, mdl_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Descripcion_AMostrar, null);
                ex_cbo_P_AgrupacionTerminal_Terminales_RegistrosSeleccionados_OrdenListado.Items.Add(mdl_INTERNO_ComboBox_Modelo);
            }
        }

        private void CrearColumnas_Terminales_RegistrosSeleccionados()
        {
            ex_dgv_P_AgrupacionTerminal_Terminales_RegistrosSeleccionados_Listado.AutoGenerateColumns = false;

            g_obj_Controladora.g_lst_INTERNO_ABS_Listado_ColumnasDatos_Modelo_Terminales_RegistrosSeleccionados_Columnas = g_obj_Controladora.g_obj_ABS_Listado_HPV_Terminales_P_AgrupacionTerminal.LISTADO_COLUMNAS().Values.ToList();

            foreach (INTERNO_ABS_Listado_ColumnasDatos_Modelo mdl_INTERNO_ABS_Listado_ColumnasDatos_Modelo in g_obj_Controladora.g_lst_INTERNO_ABS_Listado_ColumnasDatos_Modelo_Terminales_RegistrosSeleccionados_Columnas)
            {
                dynamic dgv_Columna = new DataGridViewTextBoxColumn();
                dgv_Columna.ReadOnly = true;

                dgv_Columna.DataPropertyName = mdl_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Descripcion_Interna;
                dgv_Columna.Name = mdl_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Descripcion_Interna;
                dgv_Columna.HeaderText = mdl_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Descripcion_AMostrar;

                //Poner visible o no .........................................................................
                bool bol_Visible = true;
                if (mdl_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Oculto)
                {
                    bol_Visible = false;
                }
                else if (g_mdl_INTERNO_ConfiguracionPantalla_Modelo_TERMINALES_REGISTROSSELECCIONADOS != null &&
                         g_mdl_INTERNO_ConfiguracionPantalla_Modelo_TERMINALES_REGISTROSSELECCIONADOS.LISTADO_COLUMNASAMOSTRAR != null &&
                         g_mdl_INTERNO_ConfiguracionPantalla_Modelo_TERMINALES_REGISTROSSELECCIONADOS.LISTADO_COLUMNASAMOSTRAR.Count > 0)
                {
                    if (!g_mdl_INTERNO_ConfiguracionPantalla_Modelo_TERMINALES_REGISTROSSELECCIONADOS.LISTADO_COLUMNASAMOSTRAR.Contains(mdl_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Descripcion_Interna))
                    {
                        bol_Visible = false;
                    }
                }
                else if (mdl_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Mostrado_PorDefecto == false)
                {
                    bol_Visible = false;
                }
                dgv_Columna.Visible = bol_Visible;

                if (bol_Visible)
                {
                    g_obj_Controladora.g_lst_ColumnasAMostrar_Terminales_RegistrosSeleccionados.Add(mdl_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Descripcion_Interna);
                }
                g_obj_Controladora.g_lst_Columnas_Terminales_RegistrosSeleccionados.Add(mdl_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Descripcion_Interna);
                //.....................................................................................................

                //Tipo de Formateo si fuera Fecha
                if (mdl_INTERNO_ABS_Listado_ColumnasDatos_Modelo.TipoDato.Equals(G_ENUM_TIPOSDATOS.DATETIME))
                {
                    dgv_Columna.DefaultCellStyle.Format = "d";
                }

                //Poner Ancho Columna ................................................................................
                if (g_mdl_INTERNO_ConfiguracionPantalla_Modelo_TERMINALES_REGISTROSSELECCIONADOS != null &&
                    g_mdl_INTERNO_ConfiguracionPantalla_Modelo_TERMINALES_REGISTROSSELECCIONADOS.LISTADO_COLUMNAS_ANCHO != null &&
                    g_mdl_INTERNO_ConfiguracionPantalla_Modelo_TERMINALES_REGISTROSSELECCIONADOS.LISTADO_COLUMNAS_ANCHO.Count > 0 &&
                    g_mdl_INTERNO_ConfiguracionPantalla_Modelo_TERMINALES_REGISTROSSELECCIONADOS.LISTADO_COLUMNAS_ANCHO.ContainsKey(mdl_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Descripcion_Interna))
                {
                    dgv_Columna.Width = g_mdl_INTERNO_ConfiguracionPantalla_Modelo_TERMINALES_REGISTROSSELECCIONADOS.LISTADO_COLUMNAS_ANCHO[mdl_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Descripcion_Interna];
                }
                else
                {
                    if (mdl_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Ancho > 0)
                    {
                        dgv_Columna.Width = mdl_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Ancho;
                    }
                }
                //................................................................................................................

                //Poner alineado segun tipo de datos ......................................................................................
                if (mdl_INTERNO_ABS_Listado_ColumnasDatos_Modelo.TipoDato.Equals(G_ENUM_TIPOSDATOS.DECIMAL) ||
                    mdl_INTERNO_ABS_Listado_ColumnasDatos_Modelo.TipoDato.Equals(G_ENUM_TIPOSDATOS.LONG) ||
                    mdl_INTERNO_ABS_Listado_ColumnasDatos_Modelo.TipoDato.Equals(G_ENUM_TIPOSDATOS.LONG_TEXT) ||
                    mdl_INTERNO_ABS_Listado_ColumnasDatos_Modelo.TipoDato.Equals(G_ENUM_TIPOSDATOS.INT))
                {
                    dgv_Columna.DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleRight;
                }
                else
                {
                    dgv_Columna.DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleLeft;
                }
                //..............................................................................................................................

                ex_dgv_P_AgrupacionTerminal_Terminales_RegistrosSeleccionados_Listado.Columns.Add(dgv_Columna);

            }

            //Cambiar el orden de las columnas ........
            if (g_mdl_INTERNO_ConfiguracionPantalla_Modelo_TERMINALES_REGISTROSSELECCIONADOS != null && g_mdl_INTERNO_ConfiguracionPantalla_Modelo_TERMINALES_REGISTROSSELECCIONADOS.LISTADO_COLUMNAS_ORDEN != null && g_mdl_INTERNO_ConfiguracionPantalla_Modelo_TERMINALES_REGISTROSSELECCIONADOS.LISTADO_COLUMNAS_ORDEN.Count > 0)
            {
                foreach (KeyValuePair<string, int> kvp_Valores in g_mdl_INTERNO_ConfiguracionPantalla_Modelo_TERMINALES_REGISTROSSELECCIONADOS.LISTADO_COLUMNAS_ORDEN)
                {
                    ex_dgv_P_AgrupacionTerminal_Terminales_RegistrosSeleccionados_Listado.Columns[kvp_Valores.Key].DisplayIndex = kvp_Valores.Value;
                }
            }
            //.........................................
        }

        #region Orden
        private void ex_btn_P_AgrupacionTerminal_Terminales_RegistrosSeleccionados_OrdenListado_Click(object sender, EventArgs e)
        {
            //Esta Descedente
            if (ex_btn_P_AgrupacionTerminal_Terminales_RegistrosSeleccionados_OrdenListado.Tag.ToString().Equals("1"))
            {
                Funciones.Cambiar_Imagen_Boton_Orden(1, ex_btn_P_AgrupacionTerminal_Terminales_RegistrosSeleccionados_OrdenListado);
            }
            //Esta Ascendente
            else
            {
                Funciones.Cambiar_Imagen_Boton_Orden(0, ex_btn_P_AgrupacionTerminal_Terminales_RegistrosSeleccionados_OrdenListado);
            }

            Listado_Terminales_RegistrosSeleccionados_Ordenar_DataGridView();
        }
        private void ex_dgv_P_AgrupacionTerminal_Terminales_RegistrosSeleccionados_Listado_ColumnHeaderMouseClick(object sender, DataGridViewCellMouseEventArgs e)
        {
            try
            {
                //Mostrar u Ocultar las columnas
                if (e.Button == MouseButtons.Left)
                {
                    string str_CambioOrdenAnterior = "";
                    if (ex_cbo_P_AgrupacionTerminal_Terminales_RegistrosSeleccionados_OrdenListado.SelectedItem != null)
                    {
                        str_CambioOrdenAnterior = ((INTERNO_ComboBox_Modelo)ex_cbo_P_AgrupacionTerminal_Terminales_RegistrosSeleccionados_OrdenListado.SelectedItem).Identificador;
                    }

                    //Seleccionar la columna en el Combo de orden
                    ex_cbo_P_AgrupacionTerminal_Terminales_RegistrosSeleccionados_OrdenListado.SelectedItem = ex_cbo_P_AgrupacionTerminal_Terminales_RegistrosSeleccionados_OrdenListado.Items.Cast<INTERNO_ComboBox_Modelo>().Where(m => m.Identificador.Equals(ex_dgv_P_AgrupacionTerminal_Terminales_RegistrosSeleccionados_Listado.Columns[e.ColumnIndex].Name)).FirstOrDefault();

                    if (str_CambioOrdenAnterior.Equals(((INTERNO_ComboBox_Modelo)ex_cbo_P_AgrupacionTerminal_Terminales_RegistrosSeleccionados_OrdenListado.SelectedItem).Identificador))
                    {
                        //Si estaba Ascendente lo pongo descendente
                        if (ex_dgv_P_AgrupacionTerminal_Terminales_RegistrosSeleccionados_Listado.SortOrder == SortOrder.Ascending)
                        {
                            Funciones.Cambiar_Imagen_Boton_Orden(1, ex_btn_P_AgrupacionTerminal_Terminales_RegistrosSeleccionados_OrdenListado);
                        }
                        //Si estaba descendente lo pongo Ascendente
                        else
                        {
                            Funciones.Cambiar_Imagen_Boton_Orden(0, ex_btn_P_AgrupacionTerminal_Terminales_RegistrosSeleccionados_OrdenListado);
                        }
                    }

                    Listado_Terminales_RegistrosSeleccionados_Ordenar_DataGridView();
                }
            }
            catch (Exception)
            { }
        }
        private void ex_cbo_P_AgrupacionTerminal_Terminales_RegistrosSeleccionados_OrdenListado_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (g_bol_BloquearPorCargaInicial_Terminales_RegistrosSeleccionados == false)
            {
                //Saber el Tipo de Ordenacion .................................
                ListSortDirection obj_ListSortDirection = ListSortDirection.Ascending;
                if (ex_btn_P_AgrupacionTerminal_Terminales_RegistrosSeleccionados_OrdenListado.Tag.ToString().Equals("1"))
                {
                    obj_ListSortDirection = ListSortDirection.Descending;
                }
                //..............................................................

                //Cambiar el tipo Orden en Listado
                ex_dgv_P_AgrupacionTerminal_Terminales_RegistrosSeleccionados_Listado.Sort(ex_dgv_P_AgrupacionTerminal_Terminales_RegistrosSeleccionados_Listado.Columns[((INTERNO_ComboBox_Modelo)ex_cbo_P_AgrupacionTerminal_Terminales_RegistrosSeleccionados_OrdenListado.SelectedItem).Identificador], obj_ListSortDirection);


                Listado_Terminales_RegistrosSeleccionados_Ordenar_DataGridView();
            }
        }

        public void Listado_Terminales_RegistrosSeleccionados_Ordenar_DataGridView()
        {
            try
            {
                if (ex_dgv_P_AgrupacionTerminal_Terminales_RegistrosSeleccionados_Listado.Rows.Count > 0)
                {
                    //Saber el Tipo de Ordenacion .................................
                    ListSortDirection obj_ListSortDirection = ListSortDirection.Ascending;
                    if (ex_btn_P_AgrupacionTerminal_Terminales_RegistrosSeleccionados_OrdenListado.Tag.ToString().Equals("1"))
                    {
                        obj_ListSortDirection = ListSortDirection.Descending;
                    }
                    //..............................................................

                    if (ex_cbo_P_AgrupacionTerminal_Terminales_RegistrosSeleccionados_OrdenListado.SelectedItem != null && ((INTERNO_ComboBox_Modelo)ex_cbo_P_AgrupacionTerminal_Terminales_RegistrosSeleccionados_OrdenListado.SelectedItem).Identificador.Trim().Length > 0)
                    {
                        ex_dgv_P_AgrupacionTerminal_Terminales_RegistrosSeleccionados_Listado.Sort(ex_dgv_P_AgrupacionTerminal_Terminales_RegistrosSeleccionados_Listado.Columns[((INTERNO_ComboBox_Modelo)ex_cbo_P_AgrupacionTerminal_Terminales_RegistrosSeleccionados_OrdenListado.SelectedItem).Identificador], obj_ListSortDirection);
                    }
                    else
                    {
                        ex_dgv_P_AgrupacionTerminal_Terminales_RegistrosSeleccionados_Listado.Sort(ex_dgv_P_AgrupacionTerminal_Terminales_RegistrosSeleccionados_Listado.Columns[g_obj_Controladora.g_obj_ABS_Listado_HPV_Terminales_P_AgrupacionTerminal.ORDENACION_NOMBRECOLUMNA_PORDEFECTO()], obj_ListSortDirection);
                    }
                }
            }
            catch (Exception)
            { }
        }
        #endregion

        #region Filtros
        private void ex_cbo_P_AgrupacionTerminal_Terminales_RegistrosSeleccionados_Filtros_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (g_bol_BloquearPorCargaInicial_Terminales_RegistrosSeleccionados == false)
            {
                //Si hay algo escrito en el textbox de busqueda se recarga el listado con filtros
                if (ex_txt_P_AgrupacionTerminal_Terminales_RegistrosSeleccionados_Busqueda.Text.Trim().Length > 0)
                {
                    g_timer_Terminales_RegistrosSeleccionados_Filtrar.Stop();
                    g_timer_Terminales_RegistrosSeleccionados_Filtrar.Start();
                }
            }
        }
        private void ex_txt_P_AgrupacionTerminal_Terminales_RegistrosSeleccionados_Busqueda_Exferia_TextBox_Evento_TextChanged(object sender, EventArgs e)
        {
            if (g_bol_BloquearPorCargaInicial_Terminales_RegistrosSeleccionados == false)
            {
                if (ex_cbo_P_AgrupacionTerminal_Terminales_RegistrosSeleccionados_Filtros.SelectedItem != null)
                {
                    g_timer_Terminales_RegistrosSeleccionados_Filtrar.Stop();
                    g_timer_Terminales_RegistrosSeleccionados_Filtrar.Start();
                }
            }
        }
        private void ex_chk_P_AgrupacionTerminal_Terminales_RegistrosSeleccionados_PalabraCompleta_CheckedChanged(object sender, EventArgs e)
        {
            if (g_bol_BloquearPorCargaInicial_Terminales_RegistrosSeleccionados == false)
            {
                g_timer_Terminales_RegistrosSeleccionados_Filtrar.Stop();
                g_timer_Terminales_RegistrosSeleccionados_Filtrar.Start();
            }
        }
        private void ex_chk_P_AgrupacionTerminal_Terminales_RegistrosSeleccionados_MayusculasMinusculas_CheckedChanged(object sender, EventArgs e)
        {
            if (g_bol_BloquearPorCargaInicial_Terminales_RegistrosSeleccionados == false)
            {
                g_timer_Terminales_RegistrosSeleccionados_Filtrar.Stop();
                g_timer_Terminales_RegistrosSeleccionados_Filtrar.Start();
            }
        }

        private void ex_btn_P_AgrupacionTerminal_Terminales_RegistrosSeleccionados_VerFiltrosCampos_Click(object sender, EventArgs e)
        {
            MostrarOcultar_Columnas_Y_Filtros_Terminales_RegistrosSeleccionados(ex_btn_P_AgrupacionTerminal_Terminales_RegistrosSeleccionados_VerFiltrosCampos.Location.X, 0);
        }
        private void MostrarOcultar_Columnas_Y_Filtros_Terminales_RegistrosSeleccionados(int _int_PosicionX, int _int_PosicionY)
        {
            PE_Listados_Filtros frm_PE_Listados_Filtros = new PE_Listados_Filtros(g_obj_Controladora.g_obj_ABS_Listado_HPV_Terminales_P_AgrupacionTerminal, ex_dgv_P_AgrupacionTerminal_Terminales_RegistrosSeleccionados_Listado.Columns, g_obj_Controladora.g_dct_ListadoFiltros_Terminales_RegistrosSeleccionados);

            frm_PE_Listados_Filtros.ShowDialog();

            if (frm_PE_Listados_Filtros.g_bol_BotonAceptar)
            {
                //Mostrar/Ocultar las Columnas que no esten en el Listado
                g_obj_Controladora.g_lst_ColumnasAMostrar_Terminales_RegistrosSeleccionados = frm_PE_Listados_Filtros.g_lst_ColumnasAMostrar;

                //Cargar Datos del Combo de Filtros ##################################################################################
                g_bol_BloquearPorCargaInicial_Terminales_RegistrosSeleccionados = true;

                //Guardar seleccion del Combo de filtros
                bool bol_Recargar_Listado_CambioBusqueda = false;
                INTERNO_ComboBox_Modelo mdl_INTERNO_ComboBox_Modelo_FILTROSELECCIONADO = null;
                if (ex_cbo_P_AgrupacionTerminal_Terminales_RegistrosSeleccionados_Filtros.SelectedItem != null)
                {
                    mdl_INTERNO_ComboBox_Modelo_FILTROSELECCIONADO = (INTERNO_ComboBox_Modelo)ex_cbo_P_AgrupacionTerminal_Terminales_RegistrosSeleccionados_Filtros.SelectedItem;
                }
                Cargar_Filtros_Textos_Terminales_RegistrosSeleccionados();

                //Existe el registro que habia seelccionado en el listado de campos mostrados
                if (mdl_INTERNO_ComboBox_Modelo_FILTROSELECCIONADO != null &&
                    g_obj_Controladora.g_lst_ColumnasAMostrar_Terminales_RegistrosSeleccionados.Where(m => m.Equals(mdl_INTERNO_ComboBox_Modelo_FILTROSELECCIONADO.Identificador)).FirstOrDefault() != null)
                {
                    ex_cbo_P_AgrupacionTerminal_Terminales_RegistrosSeleccionados_Filtros.SelectedItem = ex_cbo_P_AgrupacionTerminal_Terminales_RegistrosSeleccionados_Filtros.Items.Cast<INTERNO_ComboBox_Modelo>().ToList().Where(m => m.Identificador.Equals(mdl_INTERNO_ComboBox_Modelo_FILTROSELECCIONADO.Identificador)).FirstOrDefault();
                }
                else
                {
                    ex_cbo_P_AgrupacionTerminal_Terminales_RegistrosSeleccionados_Filtros.SelectedItem = ex_cbo_P_AgrupacionTerminal_Terminales_RegistrosSeleccionados_Filtros.Items.Cast<INTERNO_ComboBox_Modelo>().ToList().FirstOrDefault();
                    ex_txt_P_AgrupacionTerminal_Terminales_RegistrosSeleccionados_Busqueda.Text = "";

                    bol_Recargar_Listado_CambioBusqueda = true;
                }

                g_bol_BloquearPorCargaInicial_Terminales_RegistrosSeleccionados = false;
                //####################################################################################################

                //Cargar Datos del Combo de orden ##################################################################################
                g_bol_BloquearPorCargaInicial_Terminales_RegistrosSeleccionados = true;
                bool bol_Reordenar_Listado = false;
                //Guardar seleccion del Combo de orden
                INTERNO_ComboBox_Modelo mdl_INTERNO_ComboBox_Modelo_ORDENELECCIONADO = null;
                if (ex_cbo_P_AgrupacionTerminal_Terminales_RegistrosSeleccionados_OrdenListado.SelectedItem != null)
                {
                    mdl_INTERNO_ComboBox_Modelo_ORDENELECCIONADO = (INTERNO_ComboBox_Modelo)ex_cbo_P_AgrupacionTerminal_Terminales_RegistrosSeleccionados_OrdenListado.SelectedItem;
                }
                Cargar_Combo_Orden_Terminales_RegistrosSeleccionados();

                //Existe el registro que habia seelccionado en el listado de campos mostrados
                if (mdl_INTERNO_ComboBox_Modelo_ORDENELECCIONADO != null &&
                    g_obj_Controladora.g_lst_ColumnasAMostrar_Terminales_RegistrosSeleccionados.Where(m => m.Equals(mdl_INTERNO_ComboBox_Modelo_ORDENELECCIONADO.Identificador)).FirstOrDefault() != null)
                {
                    ex_cbo_P_AgrupacionTerminal_Terminales_RegistrosSeleccionados_OrdenListado.SelectedItem = ex_cbo_P_AgrupacionTerminal_Terminales_RegistrosSeleccionados_OrdenListado.Items.Cast<INTERNO_ComboBox_Modelo>().ToList().Where(m => m.Identificador.Equals(mdl_INTERNO_ComboBox_Modelo_ORDENELECCIONADO.Identificador)).FirstOrDefault();
                }
                else
                {
                    ex_cbo_P_AgrupacionTerminal_Terminales_RegistrosSeleccionados_OrdenListado.SelectedItem = ex_cbo_P_AgrupacionTerminal_Terminales_RegistrosSeleccionados_OrdenListado.Items.Cast<INTERNO_ComboBox_Modelo>().ToList().FirstOrDefault();
                    bol_Reordenar_Listado = true;
                }
                g_bol_BloquearPorCargaInicial_Terminales_RegistrosSeleccionados = false;
                //####################################################################################################


                foreach (DataGridViewColumn dgvc_ColumnasActuales in ex_dgv_P_AgrupacionTerminal_Terminales_RegistrosSeleccionados_Listado.Columns)
                {
                    //Mostrar
                    if (g_obj_Controladora.g_lst_ColumnasAMostrar_Terminales_RegistrosSeleccionados.Contains(dgvc_ColumnasActuales.Name))
                    {
                        dgvc_ColumnasActuales.Visible = true;
                    }
                    //Ocultar
                    else
                    {
                        dgvc_ColumnasActuales.Visible = false;
                    }
                }

                //Ver si hay que recargar el listado desde base de datos(Por agregar o quitar algun campo con relacion)
                if (frm_PE_Listados_Filtros.g_bol_RecargarListado)
                {
                    //Rellenar los nuevos filtros
                    g_obj_Controladora.g_dct_ListadoFiltros_Terminales_RegistrosSeleccionados = frm_PE_Listados_Filtros.g_dct_ListadoFiltros.ToDictionary(entry => entry.Key, entry => entry.Value);

                    g_obj_Controladora.Rellenar_DataGridView_Terminales_RegistrosSeleccionados(Exferia_TextBox_Terminales_RegistrosSeleccionados_Busqueda.Text);
                }
                else
                {
                    bool bol_Recargar = true;

                    if (bol_Recargar_Listado_CambioBusqueda == false)
                    {
                        //Si antes no tenia filtros y ahora tampoco no recargo el listado
                        if ((g_obj_Controladora.g_dct_ListadoFiltros_Terminales_RegistrosSeleccionados == null || g_obj_Controladora.g_dct_ListadoFiltros_Terminales_RegistrosSeleccionados.Count == 0) &&
                        (frm_PE_Listados_Filtros.g_dct_ListadoFiltros == null || frm_PE_Listados_Filtros.g_dct_ListadoFiltros.Count == 0))
                        {
                            bol_Recargar = false;
                        }
                    }

                    //Rellenar los nuevos filtros
                    g_obj_Controladora.g_dct_ListadoFiltros_Terminales_RegistrosSeleccionados = frm_PE_Listados_Filtros.g_dct_ListadoFiltros.ToDictionary(entry => entry.Key, entry => entry.Value);

                    if (bol_Recargar)
                    {
                        g_obj_Controladora.Rellenar_DataGridView_Terminales_RegistrosSeleccionados(ex_txt_P_AgrupacionTerminal_Terminales_RegistrosSeleccionados_Busqueda.Text);
                    }
                    else
                    {
                        if (bol_Reordenar_Listado)
                        {
                            Listado_Terminales_RegistrosSeleccionados_Ordenar_DataGridView();
                        }
                    }
                }
            }
        }
        #endregion

        #endregion

        #endregion

   

        #region Eventos del Paginador
        protected void ctu_Paginacion_Primera_Click(object sender, EventArgs e)
        {
            if (g_obj_Controladora.ComprobarCambios()) // Si no han habido contratiempos pasamos a la pagina indicada
            {
                if (g_obj_Funciones_Paginador.Primera())
                {
                    // Asignando al control la pagina actual.
                    Exferia_Paginador_AgrupacionTerminal.PaginaActual = g_obj_Funciones_Paginador.GetPaginaActual();

                    // Refrescamos el listado a mostrar en el form.
                    P_Base_id = g_obj_Funciones_Paginador.Objeto_Devuelto.FirstOrDefault().ID;

                    g_timer_Paginar.Stop();
                    g_timer_Paginar.Start();
                }
            }
        }
        protected void ctu_Paginacion_Anterior_Click(object sender, EventArgs e)
        {
            if (g_obj_Controladora.ComprobarCambios()) // Si no han habido contratiempos pasamos a la pagina indicada
            {
                if (g_obj_Funciones_Paginador.Anterior())
                {
                    // Asignando al control la pagina actual.
                    Exferia_Paginador_AgrupacionTerminal.PaginaActual = g_obj_Funciones_Paginador.GetPaginaActual();

                    // Refrescamos el listado a mostrar en el form.
                    P_Base_id = g_obj_Funciones_Paginador.Objeto_Devuelto.FirstOrDefault().ID;

                    g_timer_Paginar.Stop();
                    g_timer_Paginar.Start();
                }
            }
        }
        protected void ctu_Paginacion_Siguiente_Click(object sender, EventArgs e)
        {
            if (g_obj_Controladora.ComprobarCambios()) // Si no han habido contratiempos pasamos a la pagina indicada
            {
                if (g_obj_Funciones_Paginador.Siguiente())
                {
                    // Asignando al control la pagina actual.
                    Exferia_Paginador_AgrupacionTerminal.PaginaActual = g_obj_Funciones_Paginador.GetPaginaActual();

                    // Refrescamos el listado a mostrar en el form.
                    P_Base_id = g_obj_Funciones_Paginador.Objeto_Devuelto.FirstOrDefault().ID;

                    g_timer_Paginar.Stop();
                    g_timer_Paginar.Start();
                }
            }
        }
        protected void ctu_Paginacion_Ultima_Click(object sender, EventArgs e)
        {
            if (g_obj_Controladora.ComprobarCambios()) // Si no han habido contratiempos pasamos a la pagina indicada
            {
                if (g_obj_Funciones_Paginador.Ultima())
                {
                    // Asignando al control la pagina actual.
                    Exferia_Paginador_AgrupacionTerminal.PaginaActual = g_obj_Funciones_Paginador.GetPaginaActual();

                    // Refrescamos el listado a mostrar en el form.
                    P_Base_id = g_obj_Funciones_Paginador.Objeto_Devuelto.FirstOrDefault().ID;

                    g_timer_Paginar.Stop();
                    g_timer_Paginar.Start();
                }
            }
        }
        protected void txt_PaginaActual_KeyPress(object sender, KeyPressEventArgs e)
        {
            // Si pulsamos Enter.
            if (e.KeyChar.Equals('\r'))
            {
                if (g_obj_Controladora.ComprobarCambios()) // Si no han habido contratiempos pasamos a la pagina indicada
                {
                    // Asignamos a la paginacion el valor del textbox
                    g_obj_Funciones_Paginador.SetPaginaActual(Exferia_Paginador_AgrupacionTerminal.txt_ValorPaginaActual - 1);

                    // Asignando al control la pagina actual.
                    Exferia_Paginador_AgrupacionTerminal.PaginaActual = g_obj_Funciones_Paginador.GetPaginaActual();

                    // Refrescamos el listado a mostrar en el form.
                    P_Base_id = g_obj_Funciones_Paginador.Objeto_Devuelto.FirstOrDefault().ID;

                    g_timer_Paginar.Stop();

                    g_obj_Controladora.RecargarDatos();
                }
            }
        }
        #endregion

        #region Teclas de acceso rapido
        protected override bool ProcessCmdKey(ref Message msg, Keys keyData)
        {
            // Salir sin Seleccionar
            if (keyData == Keys.F10)
            {
                Salir_P_Base();
                return true;
            }
            // Grabar
            else if (keyData == Keys.F2)
            {
                Grabar();
                return true;
            }
            // Borrar
            else if (keyData == Keys.F5)
            {
                Borrar();
                return true;
            }
            return base.ProcessCmdKey(ref msg, keyData);
        }
        #endregion

        #region Controlar si se modifico algo

        private void Controlar_Modificaciones_TextBox_TextChanged(object sender, EventArgs e)
        {
            Controlar_Modificaciones();
        }

        private void Controlar_Modificaciones_ComboBox_SelectedIndexChanged(object sender, EventArgs e)
        {
            Controlar_Modificaciones();
        }

        private void Controlar_Modificaciones_CheckBox_CheckedChanged(object sender, EventArgs e)
        {
            Controlar_Modificaciones();
        }

        private void Controlar_Modificaciones_Exferia_FechaSeleccion_TextChanged(object sender, EventArgs e)
        {
            Controlar_Modificaciones();
        }

        private void Controlar_Modificaciones()
        {
            if (Enabled && g_obj_Controladora != null && g_obj_Controladora.g_bol_Termino_CargaDatos_Inicial)
            {
                P_Base_SeModificoDatosPantalla = true;
            }
        }
        #endregion

        #region Cierre de Pantalla
        private void P_AgrupacionTerminal_FormClosed(object sender, FormClosedEventArgs e)
        {
            try
            {
                #region Terminales Registros Seleccionados
                //Listado de Terminales Registros Seleccionados ....................................................................
                INTERNO_ConfiguracionPantalla_Modelo mdl_INTERNO_ConfiguracionPantalla_Modelo_Termianles_REGISTROSSELECCIONADOS = new INTERNO_ConfiguracionPantalla_Modelo();

                Dictionary<string, int> dct_ColumnasOrden_Terminales_REGISTROSSELECCIONADOS = new Dictionary<string, int>();
                Dictionary<string, int> dct_ColumnasAncho_Terminales_REGISTROSSELECCIONADOS = new Dictionary<string, int>();
                foreach (DataGridViewColumn dgv_Columnas in ex_dgv_P_AgrupacionTerminal_Terminales_RegistrosSeleccionados_Listado.Columns)
                {
                    //Campos a Mostrar
                    if (dgv_Columnas.Visible)
                    {
                        //Columnas Orden
                        dct_ColumnasOrden_Terminales_REGISTROSSELECCIONADOS.Add(dgv_Columnas.Name, dgv_Columnas.DisplayIndex);

                        //Columnas Ancho
                        dct_ColumnasAncho_Terminales_REGISTROSSELECCIONADOS.Add(dgv_Columnas.Name, dgv_Columnas.Width);
                    }
                }
                mdl_INTERNO_ConfiguracionPantalla_Modelo_Termianles_REGISTROSSELECCIONADOS.LISTADO_COLUMNASAMOSTRAR = g_obj_Controladora.g_lst_ColumnasAMostrar_Terminales_RegistrosSeleccionados;
                mdl_INTERNO_ConfiguracionPantalla_Modelo_Termianles_REGISTROSSELECCIONADOS.LISTADO_COLUMNAS_ORDEN = dct_ColumnasOrden_Terminales_REGISTROSSELECCIONADOS;
                mdl_INTERNO_ConfiguracionPantalla_Modelo_Termianles_REGISTROSSELECCIONADOS.LISTADO_COLUMNAS_ANCHO = dct_ColumnasAncho_Terminales_REGISTROSSELECCIONADOS;

                //Orden
                if (ex_cbo_P_AgrupacionTerminal_Terminales_RegistrosSeleccionados_OrdenListado.SelectedItem != null)
                {
                    mdl_INTERNO_ConfiguracionPantalla_Modelo_Termianles_REGISTROSSELECCIONADOS.LISTADO_ORDEN_COLUMNA_PORDEFECTO = ((INTERNO_ComboBox_Modelo)ex_cbo_P_AgrupacionTerminal_Terminales_RegistrosSeleccionados_OrdenListado.SelectedItem).Descripcion;
                }

                mdl_INTERNO_ConfiguracionPantalla_Modelo_Termianles_REGISTROSSELECCIONADOS.LISTADO_ORDEN_DIRECCION_PORDEFECTO = ex_btn_P_AgrupacionTerminal_Terminales_RegistrosSeleccionados_OrdenListado.Tag.ToString();

                //Actualizar la Variables General
                if (Variables.G_DCT_CONFIGURACIONPANTALLA != null && Variables.G_DCT_CONFIGURACIONPANTALLA.Count > 0)
                {
                    //Ver si ya existia
                    if (Variables.G_DCT_CONFIGURACIONPANTALLA.ContainsKey(g_obj_Controladora.g_obj_ABS_Listado_HPV_Terminales_P_AgrupacionTerminal.NOMBRELISTADO_ALMACENARCONFIGURACION()))
                    {
                        Variables.G_DCT_CONFIGURACIONPANTALLA[g_obj_Controladora.g_obj_ABS_Listado_HPV_Terminales_P_AgrupacionTerminal.NOMBRELISTADO_ALMACENARCONFIGURACION()] = mdl_INTERNO_ConfiguracionPantalla_Modelo_Termianles_REGISTROSSELECCIONADOS;
                    }
                    else
                    {
                        Variables.G_DCT_CONFIGURACIONPANTALLA.Add(g_obj_Controladora.g_obj_ABS_Listado_HPV_Terminales_P_AgrupacionTerminal.NOMBRELISTADO_ALMACENARCONFIGURACION(), mdl_INTERNO_ConfiguracionPantalla_Modelo_Termianles_REGISTROSSELECCIONADOS);
                    }
                }
                else
                {
                    Variables.G_DCT_CONFIGURACIONPANTALLA = new Dictionary<string, INTERNO_ConfiguracionPantalla_Modelo>();
                    Variables.G_DCT_CONFIGURACIONPANTALLA.Add(g_obj_Controladora.g_obj_ABS_Listado_HPV_Terminales_P_AgrupacionTerminal.NOMBRELISTADO_ALMACENARCONFIGURACION(), mdl_INTERNO_ConfiguracionPantalla_Modelo_Termianles_REGISTROSSELECCIONADOS);
                }
                
                //Actualizar el fichero XML
                Funciones_FicherosXML.ModificarXML_ConfiguracionPantallas(Variables.G_STR_CONFIGURACIONPANTALLA_TIPOPANTALLA_LISTADOS, g_obj_Controladora.g_obj_ABS_Listado_HPV_Terminales_P_AgrupacionTerminal.NOMBRELISTADO_ALMACENARCONFIGURACION(), mdl_INTERNO_ConfiguracionPantalla_Modelo_Termianles_REGISTROSSELECCIONADOS);
                //..........................................................................................................................
                #endregion
            }
            catch (Control_Errores)
            { }
            catch (Exception ex)
            {
                Control_Errores.Errores_Log(ex.Message, ex, nameof(P_AgrupacionTerminal) + "/" + nameof(P_AgrupacionTerminal_FormClosed));
            }
        }

        #endregion

    }
}
